
{*******************************************************}
{                                                       }
{       Borland Delphi Visual Component Library         }
{       TWavePlayer registration                        }
{                                                       }
{       Copyright (c) 1998-2000 Vino Rodrigues          }
{       vinorodrigues@yahoo.com                         }
{                                                       }
{       Version History:                                }
{       ----------------                                }
{                                                       }
{       1.1  30-Aug-01                                  }
{            First time I included "version history".   }
{                                                       }
{*******************************************************}

unit WaveReg;

{$D-,C-,Q-,Y-,L-}

interface

procedure Register;

implementation

uses
  Classes,
  {$IFDEF VER140}
  DesignIntf, DesignEditors,
  {$ELSE}
  DsgnIntf,
  {$ENDIF}
  Controls, Forms, Menus,
  Wave, WaveEd;

function DoEdit(const WP: TWavePlayer): Boolean;
begin
  Result := False;
  with TFormWaveEditor.Create(Application) do
  try
    Options := WP.Options;
    Sync := WP.Sync;
    Wave.Assign(WP.Wave);
    if (ShowModal = mrOk) then
    begin
      WP.Wave.Assign(Wave);
      WP.Sync := Sync;
      WP.Options := Options;
      Result := True;
    end;
  finally
    Free;
  end
end;

{ TWaveEditor }

type
  TWaveEditor = class(TClassProperty)
  public
    function GetAttributes: TPropertyAttributes; override;
    procedure Edit; override;
  end;

{ TWaveEditor }

function TWaveEditor.GetAttributes: TPropertyAttributes;
begin
  Result := [paDialog]
end;

procedure TWaveEditor.Edit;
begin
  DoEdit( TWavePlayer(GetComponent(0)) );
end;

{ TWavePlayerEditor }

type
  TWavePlayerEditor = class(TComponentEditor)
  public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
  end;

resourcestring
  sWaveEditor = '&Wave Editor...';

{ TWavePlayerEditor }

procedure TWavePlayerEditor.ExecuteVerb(Index: Integer);
var  i: Integer;
begin
  i := inherited GetVerbCount;
  if Index < i then
    inherited ExecuteVerb(Index)
  else
    case Index - i of
      0: if DoEdit( TWavePlayer(Component) ) then Designer.Modified;
    end;
end;

function TWavePlayerEditor.GetVerb(Index: Integer): string;
var  i: Integer;
begin
  i := inherited GetVerbCount;
  if Index < i then
    Result := inherited GetVerb(Index)
  else
    case Index - i of
      0: Result := sWaveEditor;
    end;
end;

function TWavePlayerEditor.GetVerbCount: Integer;
begin
  Result := inherited GetVerbCount + 1;
end;

{ Register }

procedure Register;
begin
  {$IFDEF VER140}
  GroupDescendentsWith(TWavePlayer, Controls.TControl);
  {$ENDIF}
  RegisterComponents('Additional', [TWavePlayer]);
  RegisterPropertyEditor(TypeInfo(TWave), nil, '', TWaveEditor);
  RegisterComponentEditor(TWavePlayer, TWavePlayerEditor);
end;

end.
